diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/qos-txop.cc ns-3.34/src/wifi/model/qos-txop.cc
--- ns-3.33/src/wifi/model/qos-txop.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/qos-txop.cc	2021-07-14 10:31:07.000000000 -0700
@@ -250,1234 +274,396 @@
 }
 
 Ptr<const WifiMacQueueItem>
-QosTxop::PeekNextFrame (uint8_t tid, Mac48Address recipient)
+QosTxop::PeekNextMpdu (uint8_t tid, Mac48Address recipient)
 {
-  NS_LOG_FUNCTION (this);
-  WifiMacQueue::ConstIterator it = WifiMacQueue::EMPTY;
+  return PeekNextMpdu ({nullptr, WifiMacQueue::EMPTY}, tid, recipient);
+}
+
+Ptr<const WifiMacQueueItem>
+QosTxop::PeekNextMpdu (WifiMacQueueItem::QueueIteratorPair queueIt, uint8_t tid, Mac48Address recipient)
+{
+  NS_LOG_FUNCTION (this << +tid << recipient);
 
   // lambda to peek the next frame
-  auto peek = [this, &tid, &recipient, &it] (Ptr<WifiMacQueue> queue)
+  auto peek = [this, &tid, &recipient, &queueIt] () -> WifiMacQueue::ConstIterator
     {
-      if (tid == 8 && recipient.IsGroup ())  // undefined TID and recipient
+      if (tid == 8 && recipient.IsBroadcast ())  // undefined TID and recipient
+        {
+          return queueIt.queue->PeekFirstAvailable (m_qosBlockedDestinations, queueIt.it);
+        }
+      if (m_qosBlockedDestinations->IsBlocked (recipient, tid))
         {
-          return queue->PeekFirstAvailable (m_qosBlockedDestinations, it);
+          return queueIt.queue->end ();
         }
-      return queue->PeekByTidAndAddress (tid, recipient, it);
+      return queueIt.queue->PeekByTidAndAddress (tid, recipient, queueIt.it);
     };
 
-  // check if there is a packet in the BlockAckManager retransmit queue
-  it = peek (m_baManager->GetRetransmitQueue ());
-  // remove old packets
-  while (it != m_baManager->GetRetransmitQueue ()->end () && IsQosOldPacket (*it))
+  if (queueIt.queue == nullptr && queueIt.it == WifiMacQueue::EMPTY)
     {
-      NS_LOG_DEBUG ("removing an old packet from BlockAckManager retransmit queue: " << **it);
-      it = m_baManager->GetRetransmitQueue ()->Remove (it);
-      it = peek (m_baManager->GetRetransmitQueue ());
+      // check if there is a packet in the BlockAckManager retransmit queue
+      queueIt.queue = PeekPointer (m_baManager->GetRetransmitQueue ());
     }
-  if (it != m_baManager->GetRetransmitQueue ()->end ())
+
+  if (queueIt.queue == PeekPointer (m_baManager->GetRetransmitQueue ()))
     {
-      NS_LOG_DEBUG ("packet peeked from BlockAckManager retransmit queue: " << **it);
-      return *it;
+      queueIt.it = peek ();
+      // remove old packets
+      while (queueIt.it != m_baManager->GetRetransmitQueue ()->end () && IsQosOldPacket (*queueIt.it))
+        {
+          NS_LOG_DEBUG ("Removing an old packet from BlockAckManager retransmit queue: " << **queueIt.it);
+          queueIt.it = m_baManager->GetRetransmitQueue ()->Remove (queueIt.it);
+          queueIt.it = peek ();
+        }
+      if (queueIt.it != m_baManager->GetRetransmitQueue ()->end ())
+        {
+          NS_LOG_DEBUG ("Packet peeked from BlockAckManager retransmit queue: " << **queueIt.it);
+          return *queueIt.it;
+        }
+      // otherwise, check if there is a packet in the EDCA queue
+      queueIt = {PeekPointer (m_queue), WifiMacQueue::EMPTY};
     }
 
-  // otherwise, check if there is a packet in the EDCA queue
-  it = WifiMacQueue::EMPTY;
-  it = peek (m_queue);
-  if (it != m_queue->end ())
+  queueIt.it = peek ();
+  if (queueIt.it != m_queue->end ())
     {
       // peek the next sequence number and check if it is within the transmit window
       // in case of QoS data frame
-      uint16_t sequence = m_txMiddle->PeekNextSequenceNumberFor (&(*it)->GetHeader ());
-      if ((*it)->GetHeader ().IsQosData ())
+      uint16_t sequence = m_txMiddle->PeekNextSequenceNumberFor (&(*queueIt.it)->GetHeader ());
+      if ((*queueIt.it)->GetHeader ().IsQosData ())
         {
-          Mac48Address recipient = (*it)->GetHeader ().GetAddr1 ();
-          uint8_t tid = (*it)->GetHeader ().GetQosTid ();
+          Mac48Address recipient = (*queueIt.it)->GetHeader ().GetAddr1 ();
+          uint8_t tid = (*queueIt.it)->GetHeader ().GetQosTid ();
 
           if (GetBaAgreementEstablished (recipient, tid)
               && !IsInWindow (sequence, GetBaStartingSequence (recipient, tid), GetBaBufferSize (recipient, tid)))
             {
-              NS_LOG_DEBUG ("packet beyond the end of the current transmit window");
+              NS_LOG_DEBUG ("Packet beyond the end of the current transmit window");
               return 0;
             }
         }
 
-      WifiMacHeader hdr = (*it)->GetHeader ();
-      hdr.SetSequenceNumber (sequence);
-      hdr.SetFragmentNumber (0);
-      hdr.SetNoMoreFragments ();
-      hdr.SetNoRetry ();
-      Ptr<const WifiMacQueueItem> item = Create<const WifiMacQueueItem> ((*it)->GetPacket (), hdr, (*it)->GetTimeStamp ());
-      NS_LOG_DEBUG ("packet peeked from EDCA queue: " << *item);
-      return item;
+      WifiMacHeader& hdr = (*queueIt.it)->GetHeader ();
+      // Assign a sequence number if this is not a fragment nor a retransmission
+      if (!(*queueIt.it)->IsFragment () && !hdr.IsRetry ())
+        {
+          hdr.SetSequenceNumber (sequence);
+        }
+      NS_LOG_DEBUG ("Packet peeked from EDCA queue: " << **queueIt.it);
+      return *queueIt.it;
     }
 
   return 0;
 }
 
 Ptr<WifiMacQueueItem>
-QosTxop::DequeuePeekedFrame (Ptr<const WifiMacQueueItem> peekedItem, WifiTxVector txVector,
-                             bool aggregate, uint32_t ampduSize, Time ppduDurationLimit)
+QosTxop::GetNextMpdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
+                      Time availableTime, bool initialFrame, WifiMacQueueItem::QueueIteratorPair& queueIt)
 {
-  NS_LOG_FUNCTION (this << peekedItem << txVector << ampduSize << ppduDurationLimit);
   NS_ASSERT (peekedItem != 0);
-
-  // do not dequeue the frame if it is a QoS data frame that does not meet the
-  // max A-MPDU size limit (if applicable) or the duration limit (if applicable)
-  if (peekedItem->GetHeader ().IsQosData () &&
-      !m_low->IsWithinSizeAndTimeLimits (peekedItem, txVector, ampduSize, ppduDurationLimit))
-    {
-      return 0;
-    }
+  NS_ASSERT (m_qosFem != 0);
+  NS_LOG_FUNCTION (this << *peekedItem << &txParams << availableTime << initialFrame);
 
   Mac48Address recipient = peekedItem->GetHeader ().GetAddr1 ();
-  Ptr<WifiMacQueueItem> item;
-  Ptr<const WifiMacQueueItem> testItem;
-  WifiMacQueue::ConstIterator testIt;
-
-  // the packet can only have been peeked from the block ack manager retransmit
-  // queue if:
-  // - the peeked packet is a QoS Data frame AND
-  // - the peeked packet is not a group addressed frame AND
-  // - an agreement has been established
-  if (peekedItem->GetHeader ().IsQosData () && !recipient.IsGroup ()
-      && GetBaAgreementEstablished (recipient, peekedItem->GetHeader ().GetQosTid ()))
-    {
-      uint8_t tid = peekedItem->GetHeader ().GetQosTid ();
-      testIt = m_baManager->GetRetransmitQueue ()->PeekByTidAndAddress (tid, recipient);
 
-      if (testIt != m_baManager->GetRetransmitQueue ()->end ())
-        {
-          testItem = *testIt;
-          // if not null, the test packet must equal the peeked packet
-          NS_ASSERT (testItem->GetPacket () == peekedItem->GetPacket ());
-          // we should not be asked to dequeue an old packet
-          NS_ASSERT (!QosUtilsIsOldPacket (GetBaStartingSequence (recipient, tid),
-                                           testItem->GetHeader ().GetSequenceNumber ()));
-          item = m_baManager->GetRetransmitQueue ()->Dequeue (testIt);
-          NS_LOG_DEBUG ("dequeued from BA manager queue: " << *item);
-          return item;
-        }
-    }
+  // The TXOP limit can be exceeded by the TXOP holder if it does not transmit more
+  // than one Data or Management frame in the TXOP and the frame is not in an A-MPDU
+  // consisting of more than one MPDU (Sec. 10.22.2.8 of 802.11-2016)
+  Time actualAvailableTime = (initialFrame && txParams.GetSize (recipient) == 0
+                              ? Time::Min () : availableTime);
+
+  if (!m_qosFem->TryAddMpdu (peekedItem, txParams, actualAvailableTime))
+    {
+      return nullptr;
+    }
+
+  NS_ASSERT (peekedItem->IsQueued ());
+  NS_ASSERT_MSG (peekedItem->GetQueueIteratorPairs ().size () == 1,
+                 "An item in the MAC queue cannot contain an A-MSDU");
+  WifiMacQueueItem::QueueIteratorPair peekedIt = peekedItem->GetQueueIteratorPairs ().front ();
+  NS_ASSERT ((*peekedIt.it)->GetPacket () == peekedItem->GetPacket ());
+
+  if (peekedIt.queue == PeekPointer (m_baManager->GetRetransmitQueue ()))
+    {
+      // the packet can only have been peeked from the block ack manager retransmit
+      // queue if:
+      // - the peeked packet is a QoS Data frame AND
+      // - the peeked packet is not a broadcast frame AND
+      // - an agreement has been established
+      NS_ASSERT (peekedItem->GetHeader ().IsQosData () && !recipient.IsBroadcast ());
+      uint8_t tid = peekedItem->GetHeader ().GetQosTid ();
+      NS_ASSERT (GetBaAgreementEstablished (recipient, tid));
+      // we should not be asked to dequeue an old packet
+      NS_ASSERT (!QosUtilsIsOldPacket (GetBaStartingSequence (recipient, tid),
+                                       peekedItem->GetHeader ().GetSequenceNumber ()));
+      // we should not be asked to dequeue an MPDU that is beyond the transmit window
+      NS_ASSERT (IsInWindow (peekedItem->GetHeader ().GetSequenceNumber (),
+                             GetBaStartingSequence (recipient, tid),
+                             GetBaBufferSize (recipient, tid)));
+      // A-MSDU aggregation cannot be done on a retransmitted MPDU, hence return
+      // the peeked MPDU
+      NS_LOG_DEBUG ("Got MPDU from BA manager queue: " << *peekedItem);
+
+      queueIt = peekedIt;
+      queueIt.it++;
+
+      return *peekedIt.it;
+    }
+
+  // The MPDU has been peeked from the EDCA queue.
+  NS_ASSERT (peekedIt.queue == PeekPointer (m_queue));
+  Ptr<WifiMacQueueItem> mpdu;
 
-  // The packet has been peeked from the EDCA queue.
-  // If it is a QoS Data frame and it is not a broadcast frame, attempt A-MSDU
-  // aggregation if aggregate is true
+  // If it is a non-broadcast QoS Data frame and it is not a retransmission nor a fragment,
+  // attempt A-MSDU aggregation
   if (peekedItem->GetHeader ().IsQosData ())
     {
       uint8_t tid = peekedItem->GetHeader ().GetQosTid ();
-      testIt = m_queue->PeekByTidAndAddress (tid, recipient);
-
-      NS_ASSERT (testIt != m_queue->end () && (*testIt)->GetPacket () == peekedItem->GetPacket ());
 
-      uint16_t sequence = m_txMiddle->PeekNextSequenceNumberFor (&peekedItem->GetHeader ());
-
-      // check if the peeked packet is within the transmit window
-      if (GetBaAgreementEstablished (recipient, tid)
-          && !IsInWindow (sequence, GetBaStartingSequence (recipient, tid), GetBaBufferSize (recipient, tid)))
-        {
-          NS_LOG_DEBUG ("packet beyond the end of the current transmit window");
-          return 0;
-        }
+      // we should not be asked to dequeue an MPDU that is beyond the transmit window.
+      // Note that PeekNextMpdu() temporarily assigns the next available sequence number
+      // to the peeked frame
+      NS_ASSERT (!GetBaAgreementEstablished (recipient, tid)
+                 || IsInWindow (peekedItem->GetHeader ().GetSequenceNumber (),
+                                GetBaStartingSequence (recipient, tid),
+                                GetBaBufferSize (recipient, tid)));
 
       // try A-MSDU aggregation
-      if (m_low->GetMsduAggregator () != 0 && !recipient.IsGroup () && aggregate)
+      if (m_stationManager->GetHtSupported () && !recipient.IsBroadcast ()
+          && !peekedItem->GetHeader ().IsRetry () && !peekedItem->IsFragment ())
         {
-          item = m_low->GetMsduAggregator ()->GetNextAmsdu (recipient, tid, txVector, ampduSize, ppduDurationLimit);
+          Ptr<HtFrameExchangeManager> htFem = StaticCast<HtFrameExchangeManager> (m_qosFem);
+          mpdu = htFem->GetMsduAggregator ()->GetNextAmsdu (peekedItem, txParams, availableTime, peekedIt);
         }
 
-      if (item != 0)
-        {
-          NS_LOG_DEBUG ("tx unicast A-MSDU");
-        }
-      else  // aggregation was not attempted or failed
+      if (mpdu != 0)
         {
-          item = m_queue->Dequeue (testIt);
+          NS_LOG_DEBUG ("Prepared an MPDU containing an A-MSDU");
         }
+      // else aggregation was not attempted or failed
     }
-  else
+
+  if (mpdu == 0)
     {
-      // the peeked packet is a non-QoS Data frame (e.g., a DELBA Request), hence
-      // it was not peeked by TID, hence it must be the head of the queue
-      item = m_queue->DequeueFirstAvailable (m_qosBlockedDestinations);
-      NS_ASSERT (item != 0 && item->GetPacket () == peekedItem->GetPacket ());
+      mpdu = *peekedIt.it;
+      peekedIt.it++;
     }
 
-  NS_ASSERT (item != 0);
-
-  // Assign a sequence number to the MSDU or A-MSDU dequeued from the EDCA queue
-  uint16_t sequence = m_txMiddle->GetNextSequenceNumberFor (&item->GetHeader ());
-  item->GetHeader ().SetSequenceNumber (sequence);
-  item->GetHeader ().SetFragmentNumber (0);
-  item->GetHeader ().SetNoMoreFragments ();
-  item->GetHeader ().SetNoRetry ();
-  NS_LOG_DEBUG ("dequeued from EDCA queue: " << *item);
+  // Assign a sequence number if this is not a fragment nor a retransmission
+  AssignSequenceNumber (mpdu);
+  NS_LOG_DEBUG ("Got MPDU from EDCA queue: " << *mpdu);
+  queueIt = peekedIt;
 
-  return item;
+  return mpdu;
 }
 
-MacLowTransmissionParameters
-QosTxop::GetTransmissionParameters (Ptr<const WifiMacQueueItem> frame) const
+void
+QosTxop::AssignSequenceNumber (Ptr<WifiMacQueueItem> mpdu) const
 {
-  NS_LOG_FUNCTION (this << *frame);
-
-  MacLowTransmissionParameters params;
-  Mac48Address recipient = frame->GetHeader ().GetAddr1 ();
-
-  params.DisableNextData ();
-
-  // group addressed frames
-  if (recipient.IsGroup ())
-    {
-      params.DisableRts ();
-      params.DisableAck ();
-      return params;
-    }
-  if (frame->GetHeader ().IsMgt ())
-    {
-      params.DisableRts ();
-      params.EnableAck ();
-      return params;
-    }
-
-  // Enable/disable RTS
-  if (!frame->GetHeader ().IsBlockAckReq ()
-      && m_stationManager->NeedRts (frame->GetHeader (), frame->GetSize ())
-      && !m_low->IsCfPeriod ())
-    {
-      params.EnableRts ();
-    }
-  else
-    {
-      params.DisableRts ();
-    }
+  NS_LOG_FUNCTION (this << *mpdu);
 
-  // Select ack technique.
-  if (frame->GetHeader ().IsQosData ())
-    {
-      // Assume normal Ack by default
-      params.EnableAck ();
-    }
-  else if (frame->GetHeader ().IsBlockAckReq ())
+  if (!mpdu->IsFragment () && !mpdu->GetHeader ().IsRetry ())
     {
-      // assume a BlockAck variant. Later, if this frame is not aggregated,
-      // the acknowledgment type will be switched to normal Ack
-      if (m_blockAckType == BASIC_BLOCK_ACK)
-        {
-          params.EnableBlockAck (BlockAckType::BASIC_BLOCK_ACK);
-        }
-      else if (m_blockAckType == COMPRESSED_BLOCK_ACK)
-        {
-          CtrlBAckRequestHeader baReqHdr;
-          frame->GetPacket ()->PeekHeader (baReqHdr);
-          uint8_t tid = baReqHdr.GetTidInfo ();
-
-          if (GetBaBufferSize (recipient, tid) > 64)
-            {
-              params.EnableBlockAck (BlockAckType::EXTENDED_COMPRESSED_BLOCK_ACK);
-            }
-          else
-            {
-              params.EnableBlockAck (BlockAckType::COMPRESSED_BLOCK_ACK);
-            }
-        }
-      else if (m_blockAckType == MULTI_TID_BLOCK_ACK)
-        {
-          NS_FATAL_ERROR ("Multi-tid block ack is not supported");
-        }
+      uint16_t sequence = m_txMiddle->GetNextSequenceNumberFor (&mpdu->GetHeader ());
+      mpdu->GetHeader ().SetSequenceNumber (sequence);
     }
+}
 
-  return params;
+BlockAckReqType
+QosTxop::GetBlockAckReqType (Mac48Address recipient, uint8_t tid) const
+{
+  return m_baManager->GetBlockAckReqType (recipient, tid);
 }
 
-void
-QosTxop::UpdateCurrentPacket (Ptr<WifiMacQueueItem> mpdu)
+BlockAckType
+QosTxop::GetBlockAckType (Mac48Address recipient, uint8_t tid) const
 {
-  NS_LOG_FUNCTION (this << *mpdu);
-  m_currentPacket = mpdu->GetPacket ();
-  m_currentHdr = mpdu->GetHeader ();
-  m_currentPacketTimestamp = mpdu->GetTimeStamp ();
+  return m_baManager->GetBlockAckType (recipient, tid);
 }
 
 void
-QosTxop::NotifyAccessGranted (void)
+QosTxop::NotifyInternalCollision (void)
 {
   NS_LOG_FUNCTION (this);
-  NS_ASSERT (m_accessRequested);
-  m_accessRequested = false;
-  m_isAccessRequestedForRts = false;
-  m_startTxop = Simulator::Now ();
-  // discard the current packet if it is a QoS Data frame with expired lifetime
-  if (m_currentPacket != 0 && m_currentHdr.IsQosData ()
-      && (m_currentPacketTimestamp + m_queue->GetMaxDelay () < Simulator::Now ()))
-    {
-      NS_LOG_DEBUG ("the lifetime of current packet expired");
-      m_currentPacket = 0;
-    }
-  // If the current packet is a QoS Data frame, then there must be no block ack agreement
-  // established with the receiver for the TID of the packet. Indeed, retransmission
-  // of MPDUs sent under a block ack agreement is handled through the retransmit queue.
-  NS_ASSERT (m_currentPacket == 0 || !m_currentHdr.IsQosData ()
-             || !GetBaAgreementEstablished (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid ()));
 
-  if (m_currentPacket == 0)
+  // For internal collisions occurring with the EDCA access method, the appropriate
+  // retry counters (short retry counter for MSDU, A-MSDU, or MMPDU and QSRC[AC] or
+  // long retry counter for MSDU, A-MSDU, or MMPDU and QLRC[AC]) are incremented
+  // (Sec. 10.22.2.11.1 of 802.11-2016).
+  // We do not prepare the PSDU that the AC losing the internal collision would have
+  // sent. As an approximation, we consider the frame peeked from the queues of the AC.
+  Ptr<const WifiMacQueueItem> mpdu = PeekNextMpdu ();
+
+  if (mpdu != nullptr)
     {
-      Ptr<const WifiMacQueueItem> peekedItem = m_baManager->GetBar ();
-      if (peekedItem != 0)
-        {
-          m_currentHdr = peekedItem->GetHeader ();
-          m_currentPacket = peekedItem->GetPacket ();
-          m_currentPacketTimestamp = Simulator::Now ();
-        }
-      else
+      m_stationManager->ReportDataFailed (mpdu);
+
+      if (!mpdu->GetHeader ().GetAddr1 ().IsGroup () && !m_stationManager->NeedRetransmission (mpdu))
         {
-          peekedItem = PeekNextFrame ();
-          if (peekedItem == 0)
-            {
-              NS_LOG_DEBUG ("no packets available for transmission");
-              return;
-            }
-          // check if a block ack agreement needs to be established
-          m_currentHdr = peekedItem->GetHeader ();
-          m_currentPacket = peekedItem->GetPacket ();
-          if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsGroup ()
-              && m_stationManager->GetQosSupported (m_currentHdr.GetAddr1 ())
-              && (!m_baManager->ExistsAgreement (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid ())
-                  || m_baManager->ExistsAgreementInState (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid (), OriginatorBlockAckAgreement::RESET))
-              && SetupBlockAckIfNeeded ())
+          NS_LOG_DEBUG ("reset DCF");
+          m_stationManager->ReportFinalDataFailed (mpdu);
+          if (!m_droppedMpduCallback.IsNull ())
             {
-              return;
+              m_droppedMpduCallback (WIFI_MAC_DROP_REACHED_RETRY_LIMIT, mpdu);
             }
+          ResetCw ();
+          // We have to discard mpdu, but first we have to determine whether mpdu
+          // is stored in the Block Ack Manager retransmit queue or in the AC queue
+          Mac48Address receiver = mpdu->GetHeader ().GetAddr1 ();
+          WifiMacQueue::ConstIterator testIt;
+          bool found = false;
 
-          m_stationManager->UpdateFragmentationThreshold ();
-          Ptr<WifiMacQueueItem> item;
-          // non-group addressed QoS Data frames may be sent in MU PPDUs. Given that at this stage
-          // we do not know the bandwidth it would be given nor the selected acknowledgment
-          // sequence, we cannot determine the constraints on size and duration limit. Hence,
-          // we only peek the non-group addressed QoS Data frame. MacLow will be in charge of
-          // computing the correct limits and dequeue the frame.
-          if (peekedItem->GetHeader ().IsQosData () && !peekedItem->GetHeader ().GetAddr1 ().IsGroup ()
-              && !NeedFragmentation ())
-            {
-              item = Copy (peekedItem);
-            }
-          else
+          if (mpdu->GetHeader ().IsQosData ()
+              && GetBaAgreementEstablished (receiver, mpdu->GetHeader ().GetQosTid ()))
             {
-              // compute the limit on the PPDU duration due to the TXOP duration, if any
-              Time ppduDurationLimit = Time::Min ();
-              if (peekedItem->GetHeader ().IsQosData () && GetTxopLimit ().IsStrictlyPositive ())
+              uint8_t tid = mpdu->GetHeader ().GetQosTid ();
+              testIt = m_baManager->GetRetransmitQueue ()->PeekByTidAndAddress (tid, receiver);
+
+              if (testIt != m_baManager->GetRetransmitQueue ()->end ())
                 {
-                  MacLowTransmissionParameters params = GetTransmissionParameters (peekedItem);
-                  ppduDurationLimit = GetTxopRemaining () - m_low->CalculateOverheadTxTime (peekedItem, params);
+                  found = true;
+                  // if not null, the test packet must equal the peeked packet
+                  NS_ASSERT ((*testIt)->GetPacket () == mpdu->GetPacket ());
+                  m_baManager->GetRetransmitQueue ()->Remove (testIt);
+                  m_baManager->NotifyDiscardedMpdu (mpdu);
                 }
-
-                // dequeue the peeked item if it fits within the TXOP duration, if any
-                item = DequeuePeekedFrame (peekedItem, m_low->GetDataTxVector (peekedItem),
-                                          !NeedFragmentation (), 0, ppduDurationLimit);
             }
 
-          if (item == 0)
+          if (!found)
             {
-              NS_LOG_DEBUG ("Not enough time in the current TXOP");
-              return;
+              if (mpdu->GetHeader ().IsQosData ())
+                {
+                  uint8_t tid = mpdu->GetHeader ().GetQosTid ();
+                  testIt = m_queue->PeekByTidAndAddress (tid, receiver);
+                  NS_ASSERT (testIt != m_queue->end () && (*testIt)->GetPacket () == mpdu->GetPacket ());
+                  m_queue->Remove (testIt);
+                }
+              else
+                {
+                  // the peeked packet is a non-QoS Data frame (e.g., a DELBA Request), hence
+                  // it was not peeked by TID, hence it must be the head of the queue
+                  Ptr<WifiMacQueueItem> item;
+                  item = m_queue->DequeueFirstAvailable (m_qosBlockedDestinations);
+                  NS_ASSERT (item != 0 && item->GetPacket () == mpdu->GetPacket ());
+                }
             }
-          m_currentPacket = item->GetPacket ();
-          m_currentHdr = item->GetHeader ();
-          m_currentPacketTimestamp = item->GetTimeStamp ();
-
-          m_fragmentNumber = 0;
-        }
-      NS_ASSERT (m_currentPacket != 0);
-    }
-  Ptr<WifiMacQueueItem> mpdu = Create <WifiMacQueueItem> (m_currentPacket, m_currentHdr,
-                                                          m_currentPacketTimestamp);
-  m_currentParams = GetTransmissionParameters (mpdu);
-
-  if (m_currentHdr.GetAddr1 ().IsGroup ())
-    {
-      NS_LOG_DEBUG ("tx broadcast");
-      m_low->StartTransmission (mpdu, m_currentParams, this);
-    }
-  //With COMPRESSED_BLOCK_ACK fragmentation must be avoided.
-  else if (((m_currentHdr.IsQosData () && !m_currentHdr.IsQosAmsdu ())
-            || (m_currentHdr.IsData () && !m_currentHdr.IsQosData ()))
-           && (GetBlockAckThreshold () == 0 || m_blockAckType == BASIC_BLOCK_ACK)
-           && NeedFragmentation ())
-    {
-      m_currentIsFragmented = true;
-      m_currentParams.DisableRts ();
-      WifiMacHeader hdr;
-      Ptr<Packet> fragment = GetFragmentPacket (&hdr);
-      if (IsLastFragment ())
-        {
-          NS_LOG_DEBUG ("fragmenting last fragment size=" << fragment->GetSize ());
-          m_currentParams.DisableNextData ();
         }
       else
         {
-          NS_LOG_DEBUG ("fragmenting size=" << fragment->GetSize ());
-          m_currentParams.EnableNextData (GetNextFragmentSize ());
+          NS_LOG_DEBUG ("Update CW");
+          UpdateFailedCw ();
         }
-      m_low->StartTransmission (Create<WifiMacQueueItem> (fragment, hdr),
-                                m_currentParams, this);
     }
-  else
+
+  GenerateBackoff ();
+  m_access = NOT_REQUESTED;
+  if (HasFramesToTransmit ())
     {
-      m_currentIsFragmented = false;
-      m_low->StartTransmission (mpdu, m_currentParams, this);
+      m_channelAccessManager->RequestAccess (this);
     }
 }
 
-void QosTxop::NotifyInternalCollision (void)
+void
+QosTxop::NotifyChannelAccessed (Time txopDuration)
 {
-  NS_LOG_FUNCTION (this);
-  bool resetTxop = false;
-  // If an internal collision is experienced, the frame involved may still
-  // be sitting in the queue, and m_currentPacket may still be null.
-  Ptr<const Packet> packet;
-  WifiMacHeader header;
-  if (m_currentPacket == 0)
-    {
-      Ptr<const WifiMacQueueItem> item = PeekNextFrame ();
-      if (item)
-        {
-          packet = item->GetPacket ();
-          header = item->GetHeader ();
-        }
-    }
-  else
-    {
-      packet = m_currentPacket;
-      header = m_currentHdr;
-    }
-  if (packet != 0)
-    {
-      if (m_isAccessRequestedForRts)
-        {
-          if (!NeedRtsRetransmission (packet, header))
-            {
-              resetTxop = true;
-              m_stationManager->ReportFinalRtsFailed (header.GetAddr1 (), &header);
-            }
-          else
-            {
-              m_stationManager->ReportRtsFailed (header.GetAddr1 (), &header);
-            }
-        }
-      else if (header.GetAddr1 () == Mac48Address::GetBroadcast ())
-        {
-          resetTxop = false;
-        }
-      else
-        {
-          if (!NeedDataRetransmission (packet, header))
-            {
-              resetTxop = true;
-              m_stationManager->ReportFinalDataFailed (header.GetAddr1 (), &header, packet->GetSize ());
-            }
-          else
-            {
-              m_stationManager->ReportDataFailed (header.GetAddr1 (), &header, packet->GetSize ());
-            }
-        }
-      if (resetTxop)
-        {
-          NS_LOG_DEBUG ("reset DCF");
-          if (!m_txFailedCallback.IsNull ())
-            {
-              m_txFailedCallback (header);
-            }
-          //to reset the Txop.
-          if (m_currentPacket)
-            {
-              NS_LOG_DEBUG ("Discarding m_currentPacket");
-              m_currentPacket = 0;
-            }
-          else
-            {
-              NS_LOG_DEBUG ("Dequeueing and discarding head of queue");
-              m_queue->Remove ();
-            }
-          ResetCw ();
-        }
-      else
-        {
-          UpdateFailedCw ();
-        }
-    }
-  GenerateBackoff ();
-  RestartAccessIfNeeded ();
+  NS_LOG_FUNCTION (this << txopDuration);
+
+  NS_ASSERT (txopDuration != Time::Min ());
+  m_startTxop = Simulator::Now ();
+  m_txopDuration = txopDuration;
+  Txop::NotifyChannelAccessed ();
+}
+
+bool
+QosTxop::IsTxopStarted (void) const
+{
+  NS_LOG_FUNCTION (this << !m_startTxop.IsZero ());
+  return (!m_startTxop.IsZero ());
 }
 
 void
-QosTxop::NotifyMissedCts (std::list<Ptr<WifiMacQueueItem>> mpduList)
+QosTxop::NotifyChannelReleased (void)
 {
   NS_LOG_FUNCTION (this);
-  NS_LOG_DEBUG ("missed cts");
-  NS_ASSERT (!mpduList.empty ());
-  if (!NeedRtsRetransmission (m_currentPacket, m_currentHdr))
-    {
-      NS_LOG_DEBUG ("Cts Fail");
-      m_stationManager->ReportFinalRtsFailed (m_currentHdr.GetAddr1 (), &m_currentHdr);
-      if (!m_txFailedCallback.IsNull ())
-        {
-          m_txFailedCallback (m_currentHdr);
-        }
-      for (auto& mpdu : mpduList)
-        {
-          m_baManager->NotifyDiscardedMpdu (mpdu);
-        }
-      //to reset the Txop.
-      m_currentPacket = 0;
-      ResetCw ();
-      m_cwTrace = GetCw ();
+
+  if (m_startTxop.IsStrictlyPositive ())
+    {
+      NS_LOG_DEBUG ("Terminating TXOP. Duration = " << Simulator::Now () - m_startTxop);
+      m_txopTrace (m_startTxop, Simulator::Now () - m_startTxop);
     }
-  else
+  m_startTxop = Seconds (0);
+  Txop::NotifyChannelReleased ();
+}
+
+Time
+QosTxop::GetRemainingTxop (void) const
+{
+  NS_ASSERT (m_startTxop.IsStrictlyPositive ());
+  Time remainingTxop = m_txopDuration;
+  remainingTxop -= (Simulator::Now () - m_startTxop);
+  if (remainingTxop.IsStrictlyNegative ())
     {
-      UpdateFailedCw ();
-      m_cwTrace = GetCw ();
-      // if a BA agreement is established, store the MPDUs in the block ack manager
-      // retransmission queue. Otherwise, this QosTxop will handle the retransmission
-      // of the (single) frame
-      if (mpduList.size () > 1 ||
-          (mpduList.front ()->GetHeader ().IsQosData ()
-           && GetBaAgreementEstablished (mpduList.front ()->GetHeader ().GetAddr1 (),
-                                         mpduList.front ()->GetHeader ().GetQosTid ())))
-        {
-          for (auto it = mpduList.rbegin (); it != mpduList.rend (); it++)
-            {
-              m_baManager->GetRetransmitQueue ()->PushFront (*it);
-            }
-          m_currentPacket = 0;
-        }
+      remainingTxop = Seconds (0);
     }
-  GenerateBackoff ();
-  RestartAccessIfNeeded ();
+  NS_LOG_FUNCTION (this << remainingTxop);
+  return remainingTxop;
 }
 
 void
-QosTxop::GotAck (void)
+QosTxop::SetAccessCategory (AcIndex ac)
 {
-  NS_LOG_FUNCTION (this);
-  if (!m_currentIsFragmented
-      || !m_currentParams.HasNextPacket ()
-      || m_currentHdr.IsQosAmsdu ())
-    {
-      NS_LOG_DEBUG ("got ack. tx done.");
-      if (!m_txOkCallback.IsNull ())
-        {
-          m_txOkCallback (m_currentHdr);
-        }
+  NS_LOG_FUNCTION (this << +ac);
+  m_ac = ac;
+}
 
-      if (m_currentHdr.IsAction ())
-        {
-          WifiActionHeader actionHdr;
-          Ptr<Packet> p = m_currentPacket->Copy ();
-          p->RemoveHeader (actionHdr);
-          if (actionHdr.GetCategory () == WifiActionHeader::BLOCK_ACK)
-            {
-              if (actionHdr.GetAction ().blockAck == WifiActionHeader::BLOCK_ACK_DELBA)
-                {
-                  MgtDelBaHeader delBa;
-                  p->PeekHeader (delBa);
-                  if (delBa.IsByOriginator ())
-                    {
-                      m_baManager->DestroyAgreement (m_currentHdr.GetAddr1 (), delBa.GetTid ());
-                    }
-                  else
-                    {
-                      m_low->DestroyBlockAckAgreement (m_currentHdr.GetAddr1 (), delBa.GetTid ());
-                    }
-                }
-              else if (actionHdr.GetAction ().blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST)
-                {
-                  // Setup ADDBA response timeout
-                  MgtAddBaRequestHeader addBa;
-                  p->PeekHeader (addBa);
-                  Simulator::Schedule (m_addBaResponseTimeout,
-                                       &QosTxop::AddBaResponseTimeout, this,
-                                       m_currentHdr.GetAddr1 (), addBa.GetTid ());
-                }
-            }
-        }
-      if (m_currentHdr.IsQosData () && GetBaAgreementEstablished (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid ()))
-        {
-          // notify the BA manager that the current packet was acknowledged
-          m_baManager->NotifyGotAck (Create<const WifiMacQueueItem> (m_currentPacket, m_currentHdr,
-                                                                     m_currentPacketTimestamp));
-        }
-      m_currentPacket = 0;
-      ResetCw ();
-    }
-  else
+void
+QosTxop::PushFront (Ptr<const Packet> packet, const WifiMacHeader &hdr)
+{
+  NS_LOG_FUNCTION (this << packet << &hdr);
+  WifiMacTrailer fcs;
+  m_queue->PushFront (Create<WifiMacQueueItem> (packet, hdr));
+  if (HasFramesToTransmit () && m_access == NOT_REQUESTED)
     {
-      NS_LOG_DEBUG ("got ack. tx not done, size=" << m_currentPacket->GetSize ());
+      m_channelAccessManager->RequestAccess (this);
     }
 }
 
 void
-QosTxop::MissedAck (void)
+QosTxop::GotAddBaResponse (const MgtAddBaResponseHeader *respHdr, Mac48Address recipient)
 {
-  NS_LOG_FUNCTION (this);
-  NS_LOG_DEBUG ("missed ack");
-  if (!NeedDataRetransmission (m_currentPacket, m_currentHdr))
+  NS_LOG_FUNCTION (this << respHdr << recipient);
+  uint8_t tid = respHdr->GetTid ();
+  if (respHdr->GetStatusCode ().IsSuccess ())
     {
-      NS_LOG_DEBUG ("Ack Fail");
-      m_stationManager->ReportFinalDataFailed (m_currentHdr.GetAddr1 (), &m_currentHdr,
-                                               m_currentPacket->GetSize ());
-      if (!m_txFailedCallback.IsNull ())
-        {
-          m_txFailedCallback (m_currentHdr);
-        }
-      if (m_currentHdr.IsAction ())
-        {
-          WifiActionHeader actionHdr;
-          m_currentPacket->PeekHeader (actionHdr);
-          if (actionHdr.GetCategory () == WifiActionHeader::BLOCK_ACK)
-            {
-              uint8_t tid = GetTid (m_currentPacket, m_currentHdr);
-              if (m_baManager->ExistsAgreementInState (m_currentHdr.GetAddr1 (), tid, OriginatorBlockAckAgreement::PENDING))
-                {
-                  NS_LOG_DEBUG ("No ACK after ADDBA request");
-                  m_baManager->NotifyAgreementNoReply (m_currentHdr.GetAddr1 (), tid);
-                  Simulator::Schedule (m_failedAddBaTimeout, &QosTxop::ResetBa, this, m_currentHdr.GetAddr1 (), tid);
-                }
-            }
-        }
-      if (GetAmpduExist (m_currentHdr.GetAddr1 ()) || m_currentHdr.IsQosData ())
+      NS_LOG_DEBUG ("block ack agreement established with " << recipient << " tid " << +tid);
+      // A (destination, TID) pair is "blocked" (i.e., no more packets are sent)
+      // when an Add BA Request is sent to the destination. However, when the
+      // Add BA Request timer expires, the (destination, TID) pair is "unblocked"
+      // and packets to the destination are sent again (under normal ack policy).
+      // Thus, there may be a packet needing to be retransmitted when the
+      // Add BA Response is received. In this case, the starting sequence number
+      // shall be set equal to the sequence number of such packet.
+      uint16_t startingSeq = m_txMiddle->GetNextSeqNumberByTidAndAddress (tid, recipient);
+      WifiMacQueue::ConstIterator peekedIt = m_queue->PeekByTidAndAddress (tid, recipient);
+      if (peekedIt != m_queue->end () && (*peekedIt)->GetHeader ().IsRetry ())
         {
-          m_baManager->NotifyDiscardedMpdu (Create<const WifiMacQueueItem> (m_currentPacket, m_currentHdr));
+          startingSeq = (*peekedIt)->GetHeader ().GetSequenceNumber ();
         }
-      m_currentPacket = 0;
-      ResetCw ();
-      m_cwTrace = GetCw ();
+      m_baManager->UpdateAgreement (respHdr, recipient, startingSeq);
     }
   else
     {
-      NS_LOG_DEBUG ("Retransmit");
-      m_stationManager->ReportDataFailed (m_currentHdr.GetAddr1 (), &m_currentHdr,
-                                          m_currentPacket->GetSize ());
-      m_currentHdr.SetRetry ();
-      if (m_currentHdr.IsQosData () && GetBaAgreementEstablished (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid ()))
-        {
-          // notify the BA manager that the current packet was not acknowledged
-          m_baManager->NotifyMissedAck (Create<WifiMacQueueItem> (m_currentPacket, m_currentHdr,
-                                                                  m_currentPacketTimestamp));
-          // let the BA manager handle its retransmission
-          m_currentPacket = 0;
-        }
-      UpdateFailedCw ();
-      m_cwTrace = GetCw ();
+      NS_LOG_DEBUG ("discard ADDBA response" << recipient);
+      m_baManager->NotifyAgreementRejected (recipient, tid);
+    }
+
+  if (HasFramesToTransmit () && m_access == NOT_REQUESTED)
+    {
+      m_channelAccessManager->RequestAccess (this);
     }
-  GenerateBackoff ();
-  RestartAccessIfNeeded ();
 }
 
 void
-QosTxop::MissedBlockAck (uint8_t nMpdus)
-{
-  NS_LOG_FUNCTION (this << +nMpdus);
-  /*
-   * If the BlockAck frame is lost, the originator may transmit a BlockAckReq
-   * frame to solicit an immediate BlockAck frame or it may retransmit the Data
-   * frames. (IEEE std 802.11-2016 sec. 10.24.7.7
-   */
-  uint8_t tid = GetTid (m_currentPacket, m_currentHdr);
-  if (m_useExplicitBarAfterMissedBlockAck || m_currentHdr.IsBlockAckReq ())
-    {
-      if (NeedBarRetransmission ())
-        {
-          NS_LOG_DEBUG ("Retransmit block ack request");
-          if (m_currentHdr.IsBlockAckReq ())
-            {
-              m_currentHdr.SetRetry ();
-              UpdateFailedCw ();
-              m_cwTrace = GetCw ();
-            }
-          else // missed BlockAck after data frame with Implicit BAR Ack Policy
-            {
-              Ptr<const WifiMacQueueItem> bar = PrepareBlockAckRequest (m_currentHdr.GetAddr1 (), tid);
-              ScheduleBar (bar);
-              m_currentPacket = 0;
-            }
-        }
-      else
-        {
-          NS_LOG_DEBUG ("Block Ack Request Fail");
-          // if a BA agreement exists, we can get here if there is no outstanding
-          // MPDU whose lifetime has not expired yet.
-          m_stationManager->ReportFinalDataFailed (m_currentHdr.GetAddr1 (), &m_currentHdr,
-                                                   m_currentPacket->GetSize ());
-          if (m_baManager->ExistsAgreementInState (m_currentHdr.GetAddr1 (), tid,
-                                                   OriginatorBlockAckAgreement::ESTABLISHED))
-            {
-              // If there is any (expired) outstanding MPDU, request the BA manager to discard
-              // it, which involves the scheduling of a BAR to advance the recipient's window
-              if (m_baManager->GetNBufferedPackets (m_currentHdr.GetAddr1 (), tid) > 0)
-                {
-                  m_baManager->DiscardOutstandingMpdus (m_currentHdr.GetAddr1 (), tid);
-                }
-              // otherwise, it means that we have not received a BlockAck in response to a
-              // BlockAckRequest sent while no frame was outstanding, whose purpose was therefore
-              // to advance the recipient's window. Schedule a BlockAckRequest with
-              // skipIfNoDataQueued set to true, so that the BlockAckRequest is only sent
-              // if there are data frames queued for this recipient.
-              else
-                {
-                  ScheduleBar (PrepareBlockAckRequest (m_currentHdr.GetAddr1 (), tid), true);
-                }
-            }
-          //to reset the Txop.
-          m_currentPacket = 0;
-          ResetCw ();
-          m_cwTrace = GetCw ();
-        }
-    }
-  else
-    {
-      if (GetAmpduExist (m_currentHdr.GetAddr1 ()))
-        {
-          m_stationManager->ReportAmpduTxStatus (m_currentHdr.GetAddr1 (), 0, nMpdus, 0, 0, WifiTxVector ());
-        }
-      // implicit BAR and do not use BAR after missed BlockAck, hence try to retransmit data frames
-      if (!NeedDataRetransmission (m_currentPacket, m_currentHdr))
-        {
-          NS_LOG_DEBUG ("Block Ack Fail");
-          m_stationManager->ReportFinalDataFailed (m_currentHdr.GetAddr1 (), &m_currentHdr,
-                                                   m_currentPacket->GetSize ());
-          if (!m_txFailedCallback.IsNull ())
-            {
-              m_txFailedCallback (m_currentHdr);
-            }
-          if (m_currentHdr.IsAction ())
-            {
-              WifiActionHeader actionHdr;
-              m_currentPacket->PeekHeader (actionHdr);
-              if (actionHdr.GetCategory () == WifiActionHeader::BLOCK_ACK)
-                {
-                  uint8_t tid = GetTid (m_currentPacket, m_currentHdr);
-                  if (m_baManager->ExistsAgreementInState (m_currentHdr.GetAddr1 (), tid, OriginatorBlockAckAgreement::PENDING))
-                    {
-                      NS_LOG_DEBUG ("No ACK after ADDBA request");
-                      m_baManager->NotifyAgreementNoReply (m_currentHdr.GetAddr1 (), tid);
-                      Simulator::Schedule (m_failedAddBaTimeout, &QosTxop::ResetBa, this, m_currentHdr.GetAddr1 (), tid);
-                    }
-                }
-            }
-          //to reset the Txop.
-          m_baManager->DiscardOutstandingMpdus (m_currentHdr.GetAddr1 (), GetTid (m_currentPacket, m_currentHdr));
-          m_currentPacket = 0;
-          ResetCw ();
-          m_cwTrace = GetCw ();
-        }
-      else
-        {
-          NS_LOG_DEBUG ("Retransmit");
-          m_stationManager->ReportDataFailed (m_currentHdr.GetAddr1 (), &m_currentHdr, m_currentPacket->GetSize ());
-          m_baManager->NotifyMissedBlockAck (m_currentHdr.GetAddr1 (), tid);
-          m_currentPacket = 0;
-          UpdateFailedCw ();
-          m_cwTrace = GetCw ();
-        }
-    }
-  GenerateBackoff ();
-  RestartAccessIfNeeded ();
-}
-
-void
-QosTxop::RestartAccessIfNeeded (void)
-{
-  NS_LOG_FUNCTION (this);
-
-  // check if the BA manager retransmit queue is empty, so that expired
-  // frames (if any) are removed and a BlockAckRequest is scheduled to advance
-  // the starting sequence number of the transmit (and receiver) window
-  bool baManagerHasPackets = m_baManager->HasPackets ();
-  // remove MSDUs with expired lifetime starting from the head of the queue
-  bool queueIsNotEmpty = !m_queue->IsEmpty ();
-
-  if ((m_currentPacket != 0 || baManagerHasPackets || queueIsNotEmpty)
-      && !IsAccessRequested ())
-    {
-      Ptr<const WifiMacQueueItem> item;
-      if (m_currentPacket != 0)
-        {
-          item = Create<const WifiMacQueueItem> (m_currentPacket, m_currentHdr);
-        }
-      else
-        {
-          item = PeekNextFrame ();
-        }
-      if (item != 0)
-        {
-          m_isAccessRequestedForRts = m_stationManager->NeedRts (item->GetHeader (), item->GetSize ());
-        }
-      else
-        {
-          m_isAccessRequestedForRts = false;
-        }
-      m_channelAccessManager->RequestAccess (this);
-    }
-}
-
-void
-QosTxop::StartAccessIfNeeded (void)
-{
-  NS_LOG_FUNCTION (this);
-
-  // check if the BA manager retransmit queue is empty, so that expired
-  // frames (if any) are removed and a BlockAckRequest is scheduled to advance
-  // the starting sequence number of the transmit (and receiver) window
-  bool baManagerHasPackets = m_baManager->HasPackets ();
-  // remove MSDUs with expired lifetime starting from the head of the queue
-  bool queueIsNotEmpty = !m_queue->IsEmpty ();
-
-  if (m_currentPacket == 0
-      && (baManagerHasPackets || queueIsNotEmpty)
-      && !IsAccessRequested ())
-    {
-      Ptr<const WifiMacQueueItem> item = PeekNextFrame ();
-      if (item != 0)
-        {
-          m_isAccessRequestedForRts = m_stationManager->NeedRts (item->GetHeader (), item->GetSize ());
-        }
-      else
-        {
-          m_isAccessRequestedForRts = false;
-        }
-      m_channelAccessManager->RequestAccess (this);
-    }
-}
-
-bool
-QosTxop::NeedBarRetransmission (void)
-{
-  uint8_t tid = 0;
-  if (m_currentHdr.IsQosData ())
-    {
-      tid = m_currentHdr.GetQosTid ();
-    }
-  else if (m_currentHdr.IsBlockAckReq ())
-    {
-      CtrlBAckRequestHeader baReqHdr;
-      m_currentPacket->PeekHeader (baReqHdr);
-      tid = baReqHdr.GetTidInfo ();
-    }
-  else if (m_currentHdr.IsBlockAck ())
-    {
-      CtrlBAckResponseHeader baRespHdr;
-      m_currentPacket->PeekHeader (baRespHdr);
-      tid = baRespHdr.GetTidInfo ();
-    }
-  return m_baManager->NeedBarRetransmission (tid, m_currentHdr.GetAddr1 ());
-}
-
-void
-QosTxop::StartNextPacket (void)
-{
-  NS_LOG_FUNCTION (this);
-  NS_ASSERT (GetTxopLimit ().IsStrictlyPositive () && GetTxopRemaining ().IsStrictlyPositive ());
-
-  m_currentPacket = 0;
-  // peek the next BlockAckReq, if any
-  Ptr<const WifiMacQueueItem> nextFrame = m_baManager->GetBar (false);
-
-  if (nextFrame == 0)
-    {
-      nextFrame = PeekNextFrame ();
-    }
-
-  if (nextFrame != 0)
-    {
-      MacLowTransmissionParameters params = GetTransmissionParameters (nextFrame);
-
-      if (GetTxopRemaining () >= m_low->CalculateOverallTxTime (nextFrame->GetPacket (), &nextFrame->GetHeader (), params))
-        {
-          // check if a block ack agreement needs to be established
-          m_currentHdr = nextFrame->GetHeader ();
-          m_currentPacket = nextFrame->GetPacket ();
-          if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsGroup ()
-              && m_stationManager->GetQosSupported (m_currentHdr.GetAddr1 ())
-              && (!m_baManager->ExistsAgreement (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid ())
-                  || m_baManager->ExistsAgreementInState (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid (), OriginatorBlockAckAgreement::RESET))
-              && SetupBlockAckIfNeeded ())
-            {
-              return;
-            }
-
-          Ptr<WifiMacQueueItem> item;
-          if (nextFrame->GetHeader ().IsBlockAckReq ())
-            {
-              item = Copy (m_baManager->GetBar ());
-            }
-          // non-group addressed QoS Data frames may be sent in MU PPDUs. Given that at this stage
-          // we do not know the bandwidth it would be given nor the selected acknowledgment
-          // sequence, we cannot determine the constraints on size and duration limit. Hence,
-          // we only peek the non-group addressed QoS Data frame. MacLow will be in charge of
-          // computing the correct limits and dequeue the frame.
-          else if (nextFrame->GetHeader ().IsQosData () && !nextFrame->GetHeader ().GetAddr1 ().IsGroup ())
-            {
-              item = Copy (nextFrame);
-            }
-          else
-            {
-              // dequeue the peeked frame
-              item = DequeuePeekedFrame (nextFrame, m_low->GetDataTxVector (nextFrame));
-            }
-
-          NS_ASSERT (item != 0);
-          NS_LOG_DEBUG ("start next packet " << *item << " within the current TXOP");
-          m_currentPacket = item->GetPacket ();
-          m_currentHdr = item->GetHeader ();
-          m_currentPacketTimestamp = item->GetTimeStamp ();
-          NS_ASSERT (m_currentPacket != 0);
-
-          m_currentParams = params;
-          m_stationManager->UpdateFragmentationThreshold ();
-          m_fragmentNumber = 0;
-          GetLow ()->StartTransmission (item, m_currentParams, this);
-          return;
-        }
-    }
-
-  // terminate TXOP because no (suitable) frame was found
-  TerminateTxop ();
-}
-
-void
-QosTxop::TerminateTxop (void)
-{
-  NS_LOG_FUNCTION (this);
-  if (GetTxopLimit ().IsStrictlyPositive ())
-    {
-      NS_LOG_DEBUG ("Terminating TXOP. Duration = " << Simulator::Now () - m_startTxop);
-    }
-  m_txopTrace (m_startTxop, Simulator::Now () - m_startTxop);
-  GenerateBackoff ();
-  RestartAccessIfNeeded ();
-}
-
-Time
-QosTxop::GetTxopRemaining (void) const
-{
-  Time remainingTxop = GetTxopLimit ();
-  remainingTxop -= (Simulator::Now () - m_startTxop);
-  if (remainingTxop.IsStrictlyNegative ())
-    {
-      remainingTxop = Seconds (0);
-    }
-  NS_LOG_FUNCTION (this << remainingTxop);
-  return remainingTxop;
-}
-
-void
-QosTxop::EndTxNoAck (void)
-{
-  NS_LOG_FUNCTION (this);
-  NS_LOG_DEBUG ("a transmission that did not require an ACK just finished");
-  m_currentPacket = 0;
-  ResetCw ();
-  TerminateTxop ();
-}
-
-bool
-QosTxop::NeedFragmentation (void) const
-{
-  NS_LOG_FUNCTION (this);
-  if (m_stationManager->GetVhtSupported ()
-      || m_stationManager->GetHeSupported ()
-      || GetAmpduExist (m_currentHdr.GetAddr1 ())
-      || (m_stationManager->GetHtSupported ()
-          && m_currentHdr.IsQosData ()
-          && GetBaAgreementEstablished (m_currentHdr.GetAddr1 (), GetTid (m_currentPacket, m_currentHdr))
-          && GetLow ()->GetMpduAggregator () != 0
-          && GetLow ()->GetMpduAggregator ()->GetMaxAmpduSize (m_currentHdr.GetAddr1 (), GetTid (m_currentPacket, m_currentHdr),
-                                                               WIFI_MOD_CLASS_HT) >= m_currentPacket->GetSize ()))
-    {
-      //MSDU is not fragmented when it is transmitted using an HT-immediate or
-      //HT-delayed block ack agreement or when it is carried in an A-MPDU.
-      return false;
-    }
-  bool needTxopFragmentation = false;
-  if (GetTxopLimit ().IsStrictlyPositive () && m_currentHdr.IsData ())
-    {
-      needTxopFragmentation = (GetLow ()->CalculateOverallTxTime (m_currentPacket, &m_currentHdr, m_currentParams) > GetTxopLimit ());
-    }
-  return (needTxopFragmentation || m_stationManager->NeedFragmentation (m_currentHdr.GetAddr1 (), &m_currentHdr, m_currentPacket));
-}
-
-bool
-QosTxop::IsTxopFragmentation (void) const
-{
-  if (GetTxopLimit ().IsZero ())
-    {
-      return false;
-    }
-  if (!m_stationManager->NeedFragmentation (m_currentHdr.GetAddr1 (), &m_currentHdr, m_currentPacket)
-      || (GetTxopFragmentSize () < m_stationManager->GetFragmentSize (m_currentHdr.GetAddr1 (), &m_currentHdr,m_currentPacket, 0)))
-    {
-      return true;
-    }
-  return false;
-}
-
-uint32_t
-QosTxop::GetTxopFragmentSize (void) const
-{
-  Time txopDuration = GetTxopLimit ();
-  if (txopDuration.IsZero ())
-    {
-      return 0;
-    }
-  uint32_t maxSize = m_currentPacket->GetSize ();
-  uint32_t minSize = 0;
-  uint32_t size = 0;
-  bool found = false;
-  while (!found)
-    {
-      size = (minSize + ((maxSize - minSize) / 2));
-      if (GetLow ()->CalculateOverallTxTime (m_currentPacket, &m_currentHdr, m_currentParams, size) > txopDuration)
-        {
-          maxSize = size;
-        }
-      else
-        {
-          minSize = size;
-        }
-      if (GetLow ()->CalculateOverallTxTime (m_currentPacket, &m_currentHdr, m_currentParams, size) <= txopDuration
-          && GetLow ()->CalculateOverallTxTime (m_currentPacket, &m_currentHdr, m_currentParams, size + 1) > txopDuration)
-        {
-          found = true;
-        }
-    }
-  NS_ASSERT (size != 0);
-  return size;
-}
-
-uint32_t
-QosTxop::GetNTxopFragment (void) const
-{
-  uint32_t fragmentSize = GetTxopFragmentSize ();
-  uint32_t nFragments = (m_currentPacket->GetSize () / fragmentSize);
-  if ((m_currentPacket->GetSize () % fragmentSize) > 0)
-    {
-      nFragments++;
-    }
-  NS_LOG_DEBUG ("GetNTxopFragment returning " << nFragments);
-  return nFragments;
-}
-
-uint32_t
-QosTxop::GetTxopFragmentOffset (uint32_t fragmentNumber) const
-{
-  if (fragmentNumber == 0)
-    {
-      return 0;
-    }
-  uint32_t offset = 0;
-  uint32_t fragmentSize = GetTxopFragmentSize ();
-  uint32_t nFragments = (m_currentPacket->GetSize () / fragmentSize);
-  if ((m_currentPacket->GetSize () % fragmentSize) > 0)
-    {
-      nFragments++;
-    }
-  if (fragmentNumber < nFragments)
-    {
-      offset = (fragmentNumber * fragmentSize);
-    }
-  else
-    {
-      NS_ASSERT (false);
-    }
-  NS_LOG_DEBUG ("GetTxopFragmentOffset returning " << offset);
-  return offset;
-}
-
-uint32_t
-QosTxop::GetNextTxopFragmentSize (uint32_t fragmentNumber) const
-{
-  NS_LOG_FUNCTION (this << fragmentNumber);
-  uint32_t fragmentSize = GetTxopFragmentSize ();
-  uint32_t nFragments = GetNTxopFragment ();
-  if (fragmentNumber >= nFragments)
-    {
-      NS_LOG_DEBUG ("GetNextTxopFragmentSize returning 0");
-      return 0;
-    }
-  if (fragmentNumber == nFragments - 1)
-    {
-      fragmentSize = (m_currentPacket->GetSize () - ((nFragments - 1) * fragmentSize));
-    }
-  NS_LOG_DEBUG ("GetNextTxopFragmentSize returning " << fragmentSize);
-  return fragmentSize;
-}
-
-uint32_t
-QosTxop::GetFragmentSize (void) const
-{
-  uint32_t size;
-  if (IsTxopFragmentation ())
-    {
-      size = GetNextTxopFragmentSize (m_fragmentNumber);
-    }
-  else
-    {
-      size = m_stationManager->GetFragmentSize (m_currentHdr.GetAddr1 (), &m_currentHdr,m_currentPacket, m_fragmentNumber);
-    }
-  return size;
-}
-
-uint32_t
-QosTxop::GetNextFragmentSize (void) const
-{
-  uint32_t size;
-  if (IsTxopFragmentation ())
-    {
-      size = GetNextTxopFragmentSize (m_fragmentNumber + 1);
-    }
-  else
-    {
-      size = m_stationManager->GetFragmentSize (m_currentHdr.GetAddr1 (), &m_currentHdr,m_currentPacket, m_fragmentNumber + 1);
-    }
-  return size;
-}
-
-uint32_t
-QosTxop::GetFragmentOffset (void) const
-{
-  uint32_t offset;
-  if (IsTxopFragmentation ())
-    {
-      offset = GetTxopFragmentOffset (m_fragmentNumber);
-    }
-  else
-    {
-      offset = m_stationManager->GetFragmentOffset (m_currentHdr.GetAddr1 (), &m_currentHdr,
-                                                    m_currentPacket, m_fragmentNumber);
-    }
-  return offset;
-}
-
-bool
-QosTxop::IsLastFragment (void) const
-{
-  bool isLastFragment;
-  if (IsTxopFragmentation ())
-    {
-      isLastFragment = (m_fragmentNumber == GetNTxopFragment () - 1);
-    }
-  else
-    {
-      isLastFragment = m_stationManager->IsLastFragment (m_currentHdr.GetAddr1 (), &m_currentHdr,
-                                                         m_currentPacket, m_fragmentNumber);
-    }
-  return isLastFragment;
-}
-
-Ptr<Packet>
-QosTxop::GetFragmentPacket (WifiMacHeader *hdr)
-{
-  NS_LOG_FUNCTION (this << hdr);
-  *hdr = m_currentHdr;
-  hdr->SetFragmentNumber (m_fragmentNumber);
-  uint32_t startOffset = GetFragmentOffset ();
-  Ptr<Packet> fragment;
-  if (IsLastFragment ())
-    {
-      hdr->SetNoMoreFragments ();
-    }
-  else
-    {
-      hdr->SetMoreFragments ();
-    }
-  fragment = m_currentPacket->CreateFragment (startOffset,
-                                              GetFragmentSize ());
-  return fragment;
-}
-
-void
-QosTxop::SetAccessCategory (AcIndex ac)
-{
-  NS_LOG_FUNCTION (this << +ac);
-  m_ac = ac;
-}
-
-Mac48Address
-QosTxop::MapSrcAddressForAggregation (const WifiMacHeader &hdr)
-{
-  NS_LOG_FUNCTION (this << &hdr);
-  Mac48Address retval;
-  if (GetTypeOfStation () == STA || GetTypeOfStation () == ADHOC_STA)
-    {
-      retval = hdr.GetAddr2 ();
-    }
-  else
-    {
-      retval = hdr.GetAddr3 ();
-    }
-  return retval;
-}
-
-Mac48Address
-QosTxop::MapDestAddressForAggregation (const WifiMacHeader &hdr)
-{
-  NS_LOG_FUNCTION (this << &hdr);
-  Mac48Address retval;
-  if (GetTypeOfStation () == AP || GetTypeOfStation () == ADHOC_STA)
-    {
-      retval = hdr.GetAddr1 ();
-    }
-  else
-    {
-      retval = hdr.GetAddr3 ();
-    }
-  return retval;
-}
-
-void
-QosTxop::PushFront (Ptr<const Packet> packet, const WifiMacHeader &hdr)
-{
-  NS_LOG_FUNCTION (this << packet << &hdr);
-  WifiMacTrailer fcs;
-  m_queue->PushFront (Create<WifiMacQueueItem> (packet, hdr));
-  StartAccessIfNeeded ();
-}
-
-void
-QosTxop::GotAddBaResponse (const MgtAddBaResponseHeader *respHdr, Mac48Address recipient)
-{
-  NS_LOG_FUNCTION (this << respHdr << recipient);
-  uint8_t tid = respHdr->GetTid ();
-  if (respHdr->GetStatusCode ().IsSuccess ())
-    {
-      NS_LOG_DEBUG ("block ack agreement established with " << recipient);
-      // Even though a (destination, TID) pair is "blocked" (i.e., no more packets
-      // are sent) when an Add BA Request is sent to the destination,
-      // the current packet may still be non-null when the Add BA Response is received.
-      // In fact, if the Add BA Request timer expires, the (destination, TID) pair is
-      // "unblocked" and packets to the destination are sent again (under normal
-      // ack policy). Thus, there may be a packet needing to be retransmitted
-      // when the Add BA Response is received. If this is the case, let the block
-      // ack manager handle its retransmission.
-      if (m_currentPacket != 0 && m_currentHdr.IsQosData ()
-          && m_currentHdr.GetAddr1 () == recipient && m_currentHdr.GetQosTid () == tid)
-        {
-          Ptr<WifiMacQueueItem> mpdu = Create<WifiMacQueueItem> (m_currentPacket, m_currentHdr,
-                                                                 m_currentPacketTimestamp);
-          m_baManager->GetRetransmitQueue ()->Enqueue (mpdu);
-          m_currentPacket = 0;
-        }
-      m_baManager->UpdateAgreement (respHdr, recipient);
-    }
-  else
-    {
-      NS_LOG_DEBUG ("discard ADDBA response" << recipient);
-      m_baManager->NotifyAgreementRejected (recipient, tid);
-    }
-  RestartAccessIfNeeded ();
-}
-
-void
-QosTxop::GotDelBaFrame (const MgtDelBaHeader *delBaHdr, Mac48Address recipient)
+QosTxop::GotDelBaFrame (const MgtDelBaHeader *delBaHdr, Mac48Address recipient)
 {
   NS_LOG_FUNCTION (this << delBaHdr << recipient);
   NS_LOG_DEBUG ("received DELBA frame from=" << recipient);
